<cfscript>
/**
 * Checks to see if a specific CNPJ (Brazil) is valid.
 * 
 * @param inputCNPJ  The CNPJ to check. 
 * @return Returns a boolean. 
 * @author Fabio Terracini (fabioterracini@gmail.com) 
 * @version 1.1, February 13, 2005 
 */

function CNPJvalidate(thisCNPJ) {

	var thisCNPJdigitos = "";
	var thisDigit = 0;
	var thisCNPJlen = 0;
	var aMultipliers = ListToArray("5,4,3,2,9,8,7,6,5,4,3,2");
	
	var somaDigitoUm = 0;
	var somaDigitoDois = 0;
	var digitoUm = 0;
	var digitoDois = 0;
	var i = 0;

	thisCNPJ = Replace(thisCNPJ, " ", "", "ALL");
	thisCNPJ = Replace(thisCNPJ, ".", "", "ALL");
	thisCNPJ = Replace(thisCNPJ, "-", "", "ALL");
	thisCNPJ = Replace(thisCNPJ, "/", "", "ALL");

	thisCNPJlen = len(thisCNPJ);
	
	if (NOT (IsNumeric(thisCNPJ) AND thisCNPJlen EQ 14 AND thisCNPJ GT 0))
		return false;
	
	thisCNPJdigitos = right(thisCNPJ, 2);
	thisCNPJ = left(thisCNPJ, 12);
	
	for(i=1; i LTE 12; i=i+1) {
		thisDigit = mid(thisCNPJ, i, 1);
		somaDigitoUm = somaDigitoUm + thisDigit * aMultipliers[i];
	}
	digitoUm = somaDigitoUm * 10 MOD 11;
	if (digitoUm EQ 10)
		digitoUm = 0;
		
	ArrayInsertAt(aMultipliers, 1, 6);
	thisCNPJ = thisCNPJ & digitoUm;
		
	for(i=1; i LTE 13; i=i+1) {
		thisDigit = mid(thisCNPJ, i, 1);
		somaDigitoDois = somaDigitoDois + thisDigit * aMultipliers[i];
	}
	digitoDois = somaDigitoDois * 10 MOD 11;
	if (digitoDois EQ 10)
		digitoDois = 0;
	
	if (digitoUm & digitoDois EQ thisCNPJdigitos)
		return true;
	else
		return false;
	
}

</cfscript>



<cfset teste="98.765.432/0001-98">
<cfoutput>#CNPJvalidate(teste)#</cfoutput>